push( @Addons_WBDesktopPre, 'RelDateFilterInit' );
push( @Addons_WBDesktopPre, 'CatFilterInit' );
push( @Addons_WBDesktopPre, 'FieldFilterInit' );

$WBFilter{'AfterRelDateFilter'} = q~Only show news items posted less than X days ago~;
$WBFilter{'BeforeRelDateFilter'} = q~Only show news items posted more than X days ago~;
$WBFilter{'BeforeDateFilter'} = q~Only show news items posted before the specified date~;
$WBFilter{'AfterDateFilter'} = q~Only show news items posted after the specified date~;
$WBFilter{'CatFilter'} = q~Only show news items from the specified categories~;
$WBFilter{'FieldFilter'} = qq~Only show news items whose field F contains the search string S~;
$WBFilter{'AntiFieldFilter'} = qq~Only show news items whose field F <b>does not</b> contain the search string S~;
$WBFilter{'RegExpFieldFilter'} = qq~Only show news items whose field F contains the search string S<BR>(nearly identical to FieldFilter, but it allows regular expression searches)~;
$WBFilter{'AntiRegExpFieldFilter'} = qq~Only show news items whose field F <b>does not contain</b> the search string S<BR>(uses regular expression search)~;

$WBFEdit{'AfterRelDateFilter'} = ['RelDateFEdit','RelDateFSave'];
$WBFEdit{'BeforeRelDateFilter'} = ['RelDateFEdit','RelDateFSave'];
$WBFEdit{'BeforeDateFilter'} = ['DateFEdit','DateFSave'];
$WBFEdit{'AfterDateFilter'} = ['DateFEdit','DateFSave'];
$WBFEdit{'CatFilter'} = ['CatFEdit','CatFSave'];
$WBFEdit{'FieldFilter'} = ['FieldFEdit','FieldFSave'];
$WBFEdit{'AntiFieldFilter'} = ['FieldFEdit','FieldFSave'];
$WBFEdit{'RegExpFieldFilter'} = ['FieldFEdit','FieldFSave'];
$WBFEdit{'AntiRegExpFieldFilter'} = ['FieldFEdit','FieldFSave'];

###########################################################
###################### Initializers #######################
###########################################################

sub RelDateFilterInit {
	$curtime = time;
}

sub CatFilterInit {
	my ($res,$wbfilternum,$k);
	for( $wbfilternum = 0; $wbfilternum < @wbdirfilter; $wbfilternum++ ) {
		if( $wbdirfilter[$wbfilternum][0] =~ /(.*)CatFilter$/ ) {
			for( $k = 0; $k < @{$wbdirfilter[$wbfilternum][1]}; $k++ ) {
				unless ($wbdirfilter[$wbfilternum][1][$k] eq '(default)') {
					$filtcats{$wbdirfilter[$wbfilternum][1][$k]} = 1;
				}
				else {
					$filtcats{''} = 1;
				}
			}
		}
	}
}

sub FieldFilterInit {
	&SubmitFormFields;
}

###########################################################
######################## FEditors #########################
###########################################################

sub CatFEdit {
	my( $p, %ncperms );
	foreach $p (@_) {
		$ncperms{$p} = 'selected';
	}
	unless(@_) {
		$ncperms{'AllCategories'} = 'selected';
	}
	unless( scalar @newscategories ) {
		eval {&NewsCatLoadConfig; };
		if( $@ ) {
			eval { &NewsCatLoadConfigTeaser; };
			if( $@ ) {
				&NPdie( "<h3>The addon WorkBench requires that
				either News Categories or Teaser be installed in order for
				WorkBench to work at all.<BR><BR>Either install one or both of the
				aforementioned addons, or delete WorkBench.</h3>" );
			}
		}

	}
	print qq~<td valign="middle" align="center">
	<BR><BR>$wbdirfilter[$wbfilternum][0]<BR>$WBFilter{$wbdirfilter[$wbfilternum][0]}<BR></td><td valign="middle" align="center">
	<select name="catfilter--$wbfilternum" size="10" multiple>
	<option value="AllCategories" $ncperms{'AllCategories'}>(All Categories)</option>
	<option value="(default)" $ncperms{'(default)'}>(Default Category)</option>
	<option value="(none)" $ncperms{'(none)'}>(none selected)</option>
	~;
	foreach $p (@newscategories) {
		print qq~
		<option value="$p" $ncperms{$p}>$p</option>~;
	}

	print qq~
	</select></td>
	~;
}

sub DateFEdit {
	GetTheDate($wbdirfilter[$wbfilternum][1][0]);
	if ($ActualMonth < 10) {
	    $ActualMonth = "0$ActualMonth"; 
	}
	if ($Day < 10) {
	    $Day = "0$Day"; 
	}
	if ($Hour < 10) {
	    $Hour = "0$Hour"; 
	}
	print qq~<td valign="middle" align="center">
	<BR><BR>$wbdirfilter[$wbfilternum][0]<BR>$WBFilter{$wbdirfilter[$wbfilternum][0]}<BR></td><td valign="middle" align="center">
	Date: DD/MM/YYYY &nbsp;<input type="text" name="datefilter--$wbfilternum" value="$Day/$ActualMonth/$Year" size="10"><BR>
	Time: HH:MM:SS<input type="text" name="timefilter--$wbfilternum" value="$Hour:$Minute:$Second" size="10"><BR>
	<i>please use military time!</i>
	</td>~;
}

sub RelDateFEdit {
	print qq~<td valign="middle" align="center">
	<BR><BR>$wbdirfilter[$wbfilternum][0]<BR>$WBFilter{$wbdirfilter[$wbfilternum][0]}<BR></td><td valign="middle" align="center">
	Days: <input type="text" name="reldatefilter--$wbfilternum" value="$wbdirfilter[$wbfilternum][1][0]">
	</td>~;
}

sub FieldFEdit {
	print qq~<td valign="middle" align="center">
<BR><BR>$wbdirfilter[$wbfilternum][0]<BR>$WBFilter{$wbdirfilter[$wbfilternum][0]}<BR></td>
<td valign="middle" align="center">
Field: <select name="filterfield--$wbfilternum">
~;
	&SubmitFormFields;
	my ($p, $selected);
	my $fp = 0;
	my $default = $wbdirfilter[$wbfilternum][1][0] || 'newssubject';
	foreach $p (@formfields) {
		if( $default eq $p ) { $fp = 1; $selected = 'selected'; }
		else { $selected = ''; }
		print qq~<option value="$p" $selected>$p</option>~;
	}
	unless( $fp ) {
		print qq~<option value="$default" selected>( $default )</option>~;
	}
	print qq~</select><BR>
	or specify: <input type="text" name="filterfspec--$wbfilternum" size="8" value=""><BR>
	Search string: <input type="text" name="filterstring--$wbfilternum" value="$wbdirfilter[$wbfilternum][1][1]">
	</td>~;
}

sub CatFSave {
	my @fcats = join( ';', split(/\|x\|/, $in{"catfilter--$wbfilternum"} ) );
	$wbdirfilter[$wbfilternum][1] = [ @fcats ];
}

sub RelDateFSave {
	my $reltime = $in{"reldatefilter--$wbfilternum"};
	$wbdirfilter[$wbfilternum][1][0] = $reltime;
}

sub DateFSave {
	my $fulltime;
	my ($aday, $amon, $ayear) = split(/\D+/, $in{"datefilter--$wbfilternum"});
	my ($ahour, $amin, $asec) = split(/\D+/, $in{"timefilter--$wbfilternum"});
	$ahour = int($ahour) || 0;
	$amin = int($amin) || 0;
	$asec = int($asec) || 0;
	$amon = int($amon) || 1;
	$amon--;
	$aday = int($aday) || 1;
	$ayear = int($ayear) || 2000;
	$ayear = $ayear - 1900;
	$fulltime = 0;
	eval {
		$fulltime = timelocal($asec,$amin,$ahour, $aday, $amon, $ayear);
	};
	if ($@) { 
		NPdie("Invalid date format: $adate - parsed as (sec: $asec, min: $amin, hour: $ahour, day: $aday, month: $months{$amon}, year: $ayear). Reason: $@");  
	}
	$wbdirfilter[$wbfilternum][1][0] = $fulltime;
}

sub FieldFSave {
	$wbdirfilter[$wbfilternum][1] = [ ( $in{"filterfspec--$wbfilternum"} || $in{"filterfield--$wbfilternum"} ), $in{"filterstring--$wbfilternum"} ];
}

###########################################################
######################## FFilters #########################
###########################################################

sub AfterRelDateFilter {
	my $mintime = $_[0] * 86400;
	return ( $NewsData[$newsnum]->{'newstime'} >= ($curtime - $mintime) );
}

sub BeforeRelDateFilter {
	my $mintime = $_[0] * 86400;
	return ( $NewsData[$newsnum]->{'newstime'} < ($curtime - $mintime) );
}

sub AfterDateFilter {
	return ( $NewsData[$newsnum]->{'newstime'} >= $_[0] );
}

sub BeforeDateFilter {
	return ( $NewsData[$newsnum]->{'newstime'} < $_[0] );
}

sub CatFilter {
	return $filtcats{$NewsData[$newsnum]->{'newscat'}};
}

sub FieldFilter {
	return $NewsData[$newsnum]->{$_[0]} =~ m~\Q$_[1]\E~i;
}

sub AntiFieldFilter {
	return $NewsData[$newsnum]->{$_[0]} !~ m~\Q$_[1]\E~i;
}

sub RegExpFieldFilter {
	return $NewsData[$newsnum]->{$_[0]} =~ m~$_[1]~i;
}

sub AntiRegExpFieldFilter {
	return $NewsData[$newsnum]->{$_[0]} !~ m~$_[1]~i;
}
1;